#include <fstream.h>
#include <string.h>
#include <stdio.h>
#include "extern.h"

void load_config_file(char *config);
void unload_config_file();

/* Random Configuration Stuff Goes Here until I code it to load from a .conf file :)*/

char *s_GameServ;		// GameServ's nickname
char *gshost;			// GameServ's Hostname
char *gsident;			// GameServ's ident/username
char *servername;		// GameServ's Server
char *c_Forest;			// Forest channel
char *c_ForestTopic; 		// Forest Channel Topic
char *adminpass;		// Administrator password
char *welcomemsg;		// Welcome Message
int confloadtime;		// Welcome Message Delay

// Remote server stuff. This is used for the outgoing connection gameserv needs to make
// to a real ircd.
char *remoteserver;		// Server to connect to
char *remoteport;		// Port to connect to on remoteserver
char *remotepass;		// Password for the server link

char *playerdata; 		// File to store player data in
char *monsterdata;		// File to load monster data from

void unload_config_file()
{
    if (s_GameServ)
    	delete [] s_GameServ;
    if (gshost)
	delete [] gshost;
    if (gsident)
	delete [] gsident;
    if (servername)
	delete [] servername;
    if (c_Forest)
	delete [] c_Forest;
    if (c_ForestTopic)
	delete [] c_ForestTopic;
    if (remoteserver)
	delete [] remoteserver;
    if (remoteport)
	delete [] remoteport;
    if (remotepass)
	delete [] remotepass;
    if (playerdata)
	delete [] playerdata;
    if (monsterdata)
	delete [] monsterdata;
    if (adminpass)
	delete [] adminpass;
    if (welcomemsg)
	delete [] welcomemsg;
}

void load_config_file(char *config)
{
    char *buf, *directive, *value;
    buf = new char[1024];

    unload_config_file();

    ifstream infile;
    infile.open(config);
    if (infile.fail())
    {
	cout << "Error opening " << config << endl;
	return;
    }

    while (infile.getline(buf, 1024, '\n'))
    {
	cout << "Buf: " << buf << endl;

	if (buf[0] == '#' || buf[0] == ' ' || buf[0] == '\0' || buf[0] == '\n' || buf[0] == '\r')
	    continue;
	
	directive = strtok(buf, " ");

	if (stricmp(directive, "S_GAMESERV") == 0)
	{
	    value = strtok(NULL, " ");
	    s_GameServ = new char[strlen(value) + 1];
	    strcpy(s_GameServ, value);
	}
	else if (stricmp(directive, "GSHOST") == 0)
	{
	    value = strtok(NULL, " ");
	    gshost = new char[strlen(value) + 1];
	    strcpy(gshost, value);
	}
	else if (stricmp(directive, "GSIDENT") == 0)
	{
	    value = strtok(NULL, " ");
	    gsident = new char[strlen(value) + 1];
	    strcpy(gsident, value);
	}
	else if (stricmp(directive, "SERVERNAME") == 0)
	{
	    value = strtok(NULL, " ");
	    servername = new char[strlen(value) + 1];
	    strcpy(servername, value);
	}
	else if (stricmp(directive, "C_FOREST") == 0)
	{
	    value = strtok(NULL, " ");
	    c_Forest = new char[strlen(value) + 1];
	    strcpy(c_Forest, value);
	}
	else if (stricmp(directive, "C_FORESTTOPIC") == 0)
	{
	    value = strtok(NULL, "");
	    c_ForestTopic = new char[strlen(value) + 1];
	    strcpy(c_ForestTopic, value);
	}
	else if (stricmp(directive, "REMOTESERVER") == 0)
	{
	    value = strtok(NULL, " ");
	    remoteserver = new char[strlen(value) + 1];
	    strcpy(remoteserver, value);
	}
	else if (stricmp(directive, "REMOTEPORT") == 0)
	{
	    value = strtok(NULL, " ");
	    remoteport = new char[strlen(value) + 1];
	    strcpy(remoteport, value);
	}
	else if (stricmp(directive, "REMOTEPASS") == 0)
	{
	    value = strtok(NULL, "");
	    remotepass = new char[strlen(value) + 1];
	    strcpy(remotepass, value);
	}
	else if (stricmp(directive, "PLAYERDATA") == 0)
	{
	    value = strtok(NULL, "");
	    playerdata = new char[strlen(value) + 1];
	    strcpy(playerdata, value);
	}
	else if (stricmp(directive, "MONSTERDATA") == 0)
	{
	    value = strtok(NULL, "");
	    monsterdata = new char[strlen(value) + 1];
	    strcpy(monsterdata, value);
	}
	else if (stricmp(directive, "ADMINPASS") == 0)
	{
	    value = strtok(NULL, "");
	    adminpass = new char[strlen(value) + 1];
	    strcpy(adminpass, value);
	}
	else if (stricmp(directive, "CONFLOADTIME") == 0)
	{
	    value = strtok(NULL, " ");
	    confloadtime = stringtoint(value);
	}
	else if (stricmp(directive, "WELCOMEMSG") == 0)
	{
	    value = strtok(NULL, "");
	    welcomemsg = new char[strlen(value) + 1];
	    strcpy(welcomemsg, value);
	}
	else
	{
	    cout << "Unknown Directive. Buffer: " << buf << endl;
	    continue;
	}
    }
delete [] buf;
infile.close();
}
